# privGAN
This repository contains the source code for PrivGan - a novel approach for deterring membership inference attacks on GAN generated synthetic medical data.Currently, the repository contains the jupyter notebooks for various datasets. We will be converting the code into a library in the future.
Please visit our paper 'PrivGAN: Protecting GANs from membership inference attacks at low cost' [ArXiv Link](https://arxiv.org/abs/2001.00071) submitted at PETS 2021

### Version information 
1) Python 3.7.3 
2) Numpy 1.16.2 
3) Pandas 0.25.3 
4) Tqdm 4.38.0 
5) Keras 2.2.4 
6) Scipy 1.1.0 
7) Tensorflow 1.14.0 
8) Scikit-learn 0.20.3 


### Notebooks comparing white-box attack accuracy of privGAN and GAN on verious datasets 
1) PrivGAN_mnist.ipynb 
2) PrivGAN_mnist_fashion.ipynb 
3) PrivGAN_lfw.ipynb 
4) PrivGAN_cifar.ipynb 


### Notebooks comparing performance on downstream classification tasks
1) MNIST_down.ipynb 

### Installation
<TBD>
  
### Contribution
Please review the link here to know code of conduct https://opensource.microsoft.com/codeofconduct . Before submitting a pull request please remove all output from your notebooks by going to Cell -> All Output -> Clear
<TBD>
  
### Contact

### Copyright
Copyright (c) Microsoft Corporation.


